/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2020/04/30
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */

/*
 * 可通过读取地址0x1FFFF884获取REVID和DEVID
 * 其中位31:16表示REVID，若值为0x2500,表示中容量产品
 * 其中位15:4表示DEVID，若值为0x410(设备编码)，表示中容量产品（64KB+20KB或32KB+10KB）
 * 目前CH3F103系列仅有中容量产品
 */
void GetChipID_884(void)
{
    u32 chipUniqueID32[1];
    chipUniqueID32[0] = *(__IO u32*)(0x1FFFF884);
    printf("ID:%x\r\n",chipUniqueID32[0]);
}


/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    printf("This is printf example\r\n");

    GetChipID_884();

    while(1)
    {
    }
}
